VERSION 5.00
Begin VB.Form Map_Frm 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   Caption         =   "Sailing the Milky Way"
   ClientHeight    =   9000
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   12000
   LinkTopic       =   "Form1"
   ScaleHeight     =   600
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   800
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox Sprite_pic 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   855
      Left            =   480
      ScaleHeight     =   53
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   29
      TabIndex        =   4
      Top             =   10500
      Width           =   495
   End
   Begin VB.PictureBox Actor_Pic 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   855
      Left            =   600
      ScaleHeight     =   53
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   21
      TabIndex        =   2
      Top             =   13500
      Width           =   375
   End
   Begin VB.PictureBox MapSource_Pic 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   735
      Left            =   480
      ScaleHeight     =   45
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   21
      TabIndex        =   1
      Top             =   10500
      Width           =   375
   End
   Begin VB.Timer Timer1 
      Interval        =   500
      Left            =   720
      Top             =   240
   End
   Begin VB.PictureBox Main_Pic 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   7200
      Left            =   960
      ScaleHeight     =   480
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   640
      TabIndex        =   0
      Top             =   240
      Width           =   9600
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Space = Talk"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   375
      Index           =   2
      Left            =   8640
      TabIndex        =   7
      Top             =   8160
      Width           =   1935
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      BorderStyle     =   1  'Fixed Single
      Caption         =   "S = Status Screen"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   375
      Index           =   1
      Left            =   8640
      TabIndex        =   6
      Top             =   7800
      Width           =   1935
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Q = Quit"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   375
      Index           =   0
      Left            =   8640
      TabIndex        =   5
      Top             =   7440
      Width           =   1935
   End
   Begin VB.Label Dialogue_Lbl 
      BackStyle       =   0  'Transparent
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   1095
      Left            =   960
      TabIndex        =   3
      Top             =   7440
      Width           =   7695
   End
End
Attribute VB_Name = "Map_Frm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const DUP = 0
Const DRIGHT = 1
Const DDOWN = 2
Const DLEFT = 3
Const WAIT_FRAME = 10

Dim battle As Boolean
Dim frame_time As Integer
Dim out_map As Boolean
Dim game_over As Boolean
Dim battle_wait As Integer

Sub determine_map()

Select Case Current_Map
 Case WORLD_MAP, BOTANICAL
  MapSource_Pic = LoadPicture(App.Path & "\images\world_map.gif")
 Case SNOW_AREA_MAP, DESERT_TOWN
  MapSource_Pic = LoadPicture(App.Path & "\images\village_map.gif")
 Case LISNA_HOUSE, SCHOOL_MAP, LIBRARY_MAP, SNOW_HOUSE_MAP, LOTUS_MAP, SPACE_MAP, TOWER_MAP1, TOWER_MAP2, TOWER_MAP3, LOTUS_MAP
  MapSource_Pic = LoadPicture(App.Path & "\images\inside_map.gif")
End Select

End Sub
Sub draw_map()
Dim MIN_COL As Integer, MIN_ROW As Integer
Dim MAX_COL As Integer, MAX_ROW As Integer
Dim col As Integer
Dim row As Integer
Dim COLsrc As Integer, ROWsrc As Integer

MIN_COL = Int(Xmap / TILESIZE)
MIN_ROW = Int(Ymap / TILESIZE)
MAX_COL = MIN_COL + COL_VISIBLE + 1
MAX_ROW = MIN_ROW + ROW_VISIBLE + 1

If MAX_COL > (MAXCOL - 1) Then MAX_COL = MAXCOL - 1
If MAX_ROW > (MAXROW - 1) Then MAX_ROW = MAXROW - 1

For col = MIN_COL To MAX_COL
 For row = MIN_ROW To MAX_ROW
  COLsrc = map(Current_Map).grid(col, row).value Mod 8
  ROWsrc = Int(map(Current_Map).grid(col, row).value / 8)
  BitBlt Main_Pic.hdc, (col * TILESIZE) - Xmap, (row * TILESIZE) - Ymap, TILESIZE, TILESIZE, MapSource_Pic.hdc, COLsrc * TILESIZE, ROWsrc * TILESIZE, vbSrcCopy
 Next row
Next col
 
End Sub
Sub Curtain_Close()
Dim i As Integer

For i = 0 To SCREEN_HEIGHT / 2 Step 2
 delay (3)
 Main_Pic.Line (0, 0)-(SCREEN_WIDTH, i), vbBlack, BF
 Main_Pic.Line (0, SCREEN_HEIGHT)-(SCREEN_WIDTH, SCREEN_HEIGHT - i), vbBlack, BF
 Main_Pic.Refresh
Next i

Main_Pic.Line (0, 0)-(SCREEN_WIDTH, SCREEN_HEIGHT), 0, BF
Main_Pic.Refresh

End Sub
Sub check_special_tile()
Dim col As Integer, row As Integer
Dim text As String, i As Integer

col = Int((actor.x + Xmap) / TILESIZE)
row = Int((actor.y + Ymap) / TILESIZE)

If map(Current_Map).grid(col, row).special = EVENTS Then
   Call event_trigger
Else:

Select Case Current_Map
 Case LISNA_HOUSE
  If map(Current_Map).grid(col, row).special = EXIT_MAP Then
     actor.x = 5 * TILESIZE + TILESIZE / 2
     actor.y = 6 * TILESIZE + TILESIZE / 2
     actor.direction = DDOWN
     Current_Map = WORLD_MAP
     Xmap = 0
     Ymap = 0
     Call determine_map
     Call Curtain_Close
     Call determine_music(WORLD_MS)
     Exit Sub
  End If
   
 Case WORLD_MAP
  ' *** Botany Research Lab
  If map(Current_Map).grid(col, row).special = 5 Then
     actor.x = 3 * TILESIZE + TILESIZE / 2
     actor.y = 8 * TILESIZE + TILESIZE / 2
     actor.direction = DRIGHT
     Current_Map = BOTANICAL
     Xmap = 0
     Ymap = 0
     Call determine_map
     Call Curtain_Close
     Call determine_music(WORLD_MS)
     Exit Sub
  End If
  
  ' *** Lisna House
  If map(Current_Map).grid(col, row).special = 4 Then
     actor.x = 7 * TILESIZE + TILESIZE / 2
     actor.y = 8 * TILESIZE + TILESIZE / 2
     actor.direction = DUP
     Current_Map = LISNA_HOUSE
     Xmap = 10 * TILESIZE
     Ymap = 0
     Call determine_map
     Call Curtain_Close
      ' ** special things on Lisna House
        If Current_Map = LISNA_HOUSE Then
        text = "Resting in Lisna's house have recovered your HP + MP <PRESS SPACE BAR>": Call dialogue(text)
        Dialogue_Lbl.Caption = ""
        Call full_hp
        Call full_mp
        End If
     Call determine_music(PEACE_MS)
     Exit Sub
  End If
  
  ' *** School
  If map(Current_Map).grid(col, row).special = 12 Then
     Xmap = 0 * TILESIZE
     Ymap = 2 * TILESIZE
     actor.x = 2 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 9 * TILESIZE - Ymap + TILESIZE / 2
     Current_Map = SCHOOL_MAP
     Call determine_map
     Call Curtain_Close
     Call determine_music(SCHOOL_MS)
     Exit Sub
  End If
     
  ' ** Snow Area
  If map(Current_Map).grid(col, row).special = 22 Then
     Xmap = 0 * TILESIZE
     Ymap = 0 * TILESIZE
     actor.x = 6 * TILESIZE + TILESIZE / 2
     actor.y = 7 * TILESIZE + TILESIZE / 2
     Current_Map = SNOW_AREA_MAP
     Call determine_map
     Call Curtain_Close
     Call determine_music(PEACE_MS)
     Exit Sub
  End If
     
  ' ** Cave
  If map(Current_Map).grid(col, row).special = 1 Then
     Xmap = 0 * TILESIZE
     Ymap = 0 * TILESIZE
     actor.x = 2 * TILESIZE + TILESIZE / 2
     actor.y = 4 * TILESIZE + TILESIZE / 2
     Current_Map = SPACE_MAP
     Call determine_map
     Call Curtain_Close
     Exit Sub
  End If
  
  ' ** Desert Cave
  If map(Current_Map).grid(col, row).special = 13 Then
     Xmap = 0 * TILESIZE
     Ymap = 0 * TILESIZE
     actor.x = 13 * TILESIZE + TILESIZE / 2
     actor.y = 4 * TILESIZE + TILESIZE / 2
     Current_Map = SPACE_MAP
     Call determine_map
     Call Curtain_Close
     Exit Sub
  End If
  
  ' *** Desert Town
  If map(Current_Map).grid(col, row).special = 11 Then
     Xmap = 0 * TILESIZE
     Ymap = 0 * TILESIZE
     actor.x = 8 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 8 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DUP
     Current_Map = DESERT_TOWN
     Call determine_map
     Call Curtain_Close
     Call determine_music(PEACE_MS)
     Exit Sub
  End If
  
  ' *** Shop
  If map(Current_Map).grid(col, row).special = 8 Then
     actor.x = 18 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 6 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DDOWN
     open_status = True
     Map_Frm.Hide
     Load Shop_Frm
     Shop_Frm.Show
  End If
  
  ' *** Snow Tower
  If map(Current_Map).grid(col, row).special = 21 Then
     Xmap = 0 * TILESIZE
     Ymap = 0 * TILESIZE
     actor.x = 2 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 4 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DDOWN
     Current_Map = TOWER_MAP1
     Call determine_map
     Call Curtain_Close
     Exit Sub
  End If
  
  ' *** Desert Tower
  If map(Current_Map).grid(col, row).special = 6 Then
     Xmap = 0 * TILESIZE
     Ymap = 0 * TILESIZE
     actor.x = 2 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 4 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DDOWN
     Current_Map = TOWER_MAP2
     Call determine_map
     Call Curtain_Close
     Exit Sub
  End If
  
  ' *** Grass Tower
  If map(Current_Map).grid(col, row).special = 9 Then
     Xmap = 0 * TILESIZE
     Ymap = 0 * TILESIZE
     actor.x = 2 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 4 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DDOWN
     Current_Map = TOWER_MAP3
     Call determine_map
     Call Curtain_Close
     Exit Sub
  End If
  
  ' *** Lotus Castle
  If map(Current_Map).grid(col, row).special = 3 Then
     Xmap = 10 * TILESIZE
     Ymap = 8 * TILESIZE
     actor.x = 20 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 16 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DUP
     Current_Map = LOTUS_MAP
     Call determine_map
     Call Curtain_Close
     Call determine_music(CASTLE_MS)
     Exit Sub
  End If
     
  Case BOTANICAL
  If map(Current_Map).grid(col, row).special = EXIT_MAP Then
     Xmap = 0
     Ymap = 4 * TILESIZE
     actor.x = 1 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 11 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DDOWN
     Current_Map = WORLD_MAP
     Call determine_map
     Call Curtain_Close
     Exit Sub
  End If
  
  Case SCHOOL_MAP
  If map(Current_Map).grid(col, row).special = EXIT_MAP Then
   Select Case row
    Case 3 'library north
     Xmap = 0
     Ymap = 0
     actor.x = 3 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 3 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DRIGHT
     Current_Map = LIBRARY_MAP
     Call determine_map
     Call Curtain_Close
     Exit Sub
    
    Case 8 'library south
     Xmap = 0
     Ymap = 3 * TILESIZE
     actor.x = 4 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 10 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DUP
     Current_Map = LIBRARY_MAP
     Call determine_map
     Call Curtain_Close
     Exit Sub
    
    Case 9 'out to world map
     Xmap = 10 * TILESIZE
     Ymap = 6 * TILESIZE
     actor.x = 22 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 11 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DDOWN
     Current_Map = WORLD_MAP
     Call determine_map
     Call Curtain_Close
     Call determine_music(WORLD_MS)
     Exit Sub
    End Select
   End If
   
  Case SNOW_AREA_MAP
   If map(Current_Map).grid(col, row).special = EXIT_MAP Then
      Select Case row
       Case 4 ' enter snow_house
       Xmap = 0 * TILESIZE
       Ymap = 1 * TILESIZE
       actor.x = 7 * TILESIZE - Xmap + TILESIZE / 2
       actor.y = 8 * TILESIZE - Ymap + TILESIZE / 2
       actor.direction = DUP
       Current_Map = SNOW_HOUSE_MAP
       Call determine_map
       Call Curtain_Close
       Exit Sub
       
       Case 8 'exit to world map
       Xmap = 0 * TILESIZE
       Ymap = 5 * TILESIZE
       actor.x = 7 * TILESIZE - Xmap + TILESIZE / 2
       actor.y = 11 * TILESIZE - Ymap + TILESIZE / 2
       actor.direction = DDOWN
       Current_Map = WORLD_MAP
       Call determine_map
       Call Curtain_Close
       Call determine_music(WORLD_MS)
       Exit Sub
     
      End Select
   End If
      
  Case SNOW_HOUSE_MAP
   If map(Current_Map).grid(col, row).special = EXIT_MAP Then
       Xmap = 0 * TILESIZE
       Ymap = 0 * TILESIZE
       actor.x = 6 * TILESIZE - Xmap + TILESIZE / 2
       actor.y = 5 * TILESIZE - Ymap + TILESIZE / 2
       actor.direction = DDOWN
       Current_Map = SNOW_AREA_MAP
       Call determine_map
       Call Curtain_Close
       Exit Sub
   End If
   
  Case LIBRARY_MAP
  If map(Current_Map).grid(col, row).special = EXIT_MAP Then
     Select Case row
      Case 3 'school north
       Xmap = 0 * TILESIZE
       Ymap = 0 * TILESIZE
       actor.x = 2 * TILESIZE - Xmap + TILESIZE / 2
       actor.y = 4 * TILESIZE - Ymap + TILESIZE / 2
       actor.direction = DDOWN
       Current_Map = SCHOOL_MAP
       Call determine_map
       Call Curtain_Close
     Exit Sub
      
      Case 11 'school south
      Xmap = 0 * TILESIZE
      Ymap = 1 * TILESIZE
      actor.x = 4 * TILESIZE - Xmap + TILESIZE / 2
      actor.y = 9 * TILESIZE - Ymap + TILESIZE / 2
      actor.direction = DDOWN
      Current_Map = SCHOOL_MAP
      Call determine_map
      Call Curtain_Close
      Exit Sub
     
     End Select
  End If
  
  Case LOTUS_MAP
    If map(Current_Map).grid(col, row).special = EXIT_MAP Then
     Xmap = 2 * TILESIZE
     Ymap = 8 * TILESIZE
     actor.x = 9 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 17 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DDOWN
     Current_Map = WORLD_MAP
     Call determine_map
     Call Curtain_Close
     Call determine_music(WORLD_MS)
     Exit Sub
  End If
   
  Case TOWER_MAP1
    If map(Current_Map).grid(col, row).special = EXIT_MAP Then
     Xmap = 2 * TILESIZE
     Ymap = 5 * TILESIZE
     actor.x = 9 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 11 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DDOWN
     Current_Map = WORLD_MAP
     Call determine_map
     Call Curtain_Close
     Exit Sub
    End If
  
  Case TOWER_MAP2
   If map(Current_Map).grid(col, row).special = EXIT_MAP Then
     Xmap = 10 * TILESIZE
     Ymap = 2 * TILESIZE
     actor.x = 19 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 7 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DDOWN
     Current_Map = WORLD_MAP
     Call determine_map
     Call Curtain_Close
     Exit Sub
   End If
   
  Case TOWER_MAP3
    If map(Current_Map).grid(col, row).special = EXIT_MAP Then
     Xmap = 6 * TILESIZE
     Ymap = 0 * TILESIZE
     actor.x = 13 * TILESIZE - Xmap + TILESIZE / 2
     actor.y = 4 * TILESIZE - Ymap + TILESIZE / 2
     actor.direction = DDOWN
     Current_Map = WORLD_MAP
     Call determine_map
     Call Curtain_Close
     Exit Sub
    End If
    
  Case DESERT_TOWN
    If map(Current_Map).grid(col, row).special = EXIT_MAP Then
     Select Case row
      Case 9
       Xmap = 10 * TILESIZE
       Ymap = 1 * TILESIZE
       actor.x = 17 * TILESIZE - Xmap + TILESIZE / 2
       actor.y = 7 * TILESIZE - Ymap + TILESIZE / 2
       actor.direction = DDOWN
       Current_Map = WORLD_MAP
       Call determine_map
       Call Curtain_Close
       Call determine_music(WORLD_MS)
       Exit Sub
       
      Case Else
      
     End Select
    End If
     
  Case SPACE_MAP
    If map(Current_Map).grid(col, row).special = EXIT_MAP Then
     Select Case row
      Case 4
       Xmap = 10 * TILESIZE
       Ymap = 0 * TILESIZE
       actor.x = 22 * TILESIZE - Xmap + TILESIZE / 2
       actor.y = 2 * TILESIZE - Ymap + TILESIZE / 2
       actor.direction = DDOWN
       Current_Map = WORLD_MAP
       Call determine_map
       Call Curtain_Close
       Exit Sub
       
      Case Else
       Xmap = 10 * TILESIZE
       Ymap = 0 * TILESIZE
       actor.x = 23 * TILESIZE - Xmap + TILESIZE / 2
       actor.y = 6 * TILESIZE - Ymap + TILESIZE / 2
       actor.direction = DDOWN
       Current_Map = WORLD_MAP
       Call determine_map
       Call Curtain_Close
       Exit Sub
       
     End Select
    End If
    
End Select

End If

End Sub
Function check_scroll_map(direction As Integer)
 
 Select Case direction
  Case DLEFT
   If actor.x < 0.25 * Main_Pic.Width And Xmap > 0 Then
      Xmap = Xmap - actor.offset
      If Xmap < 0 Then Xmap = 0
   Else: actor.x = actor.x - actor.offset
   End If
   
  Case DRIGHT
   If actor.x > 0.75 * Main_Pic.Width And Xmap < MAP_WIDTH Then
      Xmap = Xmap + actor.offset
   Else: actor.x = actor.x + actor.offset
   End If
  
  Case DUP
   If actor.y < 0.25 * Main_Pic.Height And Ymap > 0 Then
      Ymap = Ymap - actor.offset
      If Ymap < 0 Then Ymap = 0
   Else: actor.y = actor.y - actor.offset
   End If
  
  Case DDOWN
   If actor.y > 0.75 * Main_Pic.Height And Ymap < MAP_HEIGHT Then
      Ymap = Ymap + actor.offset
   Else: actor.y = actor.y + actor.offset
   End If
 End Select
  
End Function
Sub check_border(direction As Integer)
Dim col As Integer, row As Integer

Select Case direction
 Case DLEFT
  col = Int((actor.x + Xmap - TILESIZE / 2) / TILESIZE)
  row = Int((actor.y + Ymap) / TILESIZE)
  If map(Current_Map).grid(col, row).special < 100 Then
   Call check_scroll_map(direction)
   Call check_special_tile
  End If
  
 Case DRIGHT
  col = Int((actor.x + Xmap + TILESIZE / 2) / TILESIZE)
  row = Int((actor.y + Ymap) / TILESIZE)
  If map(Current_Map).grid(col, row).special < 100 Then
   Call check_scroll_map(direction)
   Call check_special_tile
  End If
 
 Case DUP
  col = Int((actor.x + Xmap) / TILESIZE)
  row = Int((actor.y + Ymap - TILESIZE / 2) / TILESIZE)
  If map(Current_Map).grid(col, row).special < 100 Then
   Call check_scroll_map(direction)
   Call check_special_tile
  End If
 
 Case DDOWN
  col = Int((actor.x + Xmap) / TILESIZE)
  row = Int((actor.y + Ymap + TILESIZE / 2) / TILESIZE)
  If map(Current_Map).grid(col, row).special < 100 Then
   Call check_scroll_map(direction)
   Call check_special_tile
  End If

End Select

actor.direction = direction

End Sub
Sub check_keyboard()

If GetKeyState(vbKeyLeft) And KEY_DOWN Then Call check_border(DLEFT): Call check_battle
If GetKeyState(vbKeyRight) And KEY_DOWN Then Call check_border(DRIGHT): Call check_battle
If GetKeyState(vbKeyUp) And KEY_DOWN Then Call check_border(DUP): Call check_battle
If GetKeyState(vbKeyDown) And KEY_DOWN Then Call check_border(DDOWN): Call check_battle

If GetKeyState(vbKeySpace) And KEY_DOWN Then Call check_dialogue
If GetKeyState(vbKeyS) And KEY_DOWN Then open_status = True: Load Status_Frm: Status_Frm.Show: Map_Frm.Hide
If GetKeyState(vbKeyQ) And KEY_DOWN Then out_map = True: game_over = True

End Sub
Sub draw_actor()

BitBlt Main_Pic.hdc, actor.x - TILESIZE / 2, actor.y - TILESIZE / 2, TILESIZE, TILESIZE, Actor_Pic.hdc, (current_actor * TILESIZE * 2) + actor.Frame * TILESIZE, (actor.direction * TILESIZE) + TILESIZE * 4, vbSrcAnd
BitBlt Main_Pic.hdc, actor.x - TILESIZE / 2, actor.y - TILESIZE / 2, TILESIZE, TILESIZE, Actor_Pic.hdc, (current_actor * TILESIZE * 2) + actor.Frame * TILESIZE, actor.direction * TILESIZE, vbSrcPaint

End Sub
Sub animate()
frame_time = frame_time + 1
 If frame_time > WAIT_FRAME Then
    frame_time = 0
     If actor.Frame = 1 Then actor.Frame = 0 Else: actor.Frame = 1
 End If
End Sub
Sub draw_enemy_sprite()

Select Case Current_Map
 Case BOTANICAL
  If BOTANICAL_EVENT = False Then
     BitBlt Main_Pic.hdc, 11 * TILESIZE - Xmap, 7 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE + 2 * TILESIZE, 1 * TILESIZE, vbSrcAnd
     BitBlt Main_Pic.hdc, 11 * TILESIZE - Xmap, 7 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE, 1 * TILESIZE, vbSrcPaint
  Else:
     If BOTANICAL_EVENT2 = False Then
      BitBlt Main_Pic.hdc, 12 * TILESIZE - Xmap, 8 * TILESIZE - Ymap, TILESIZE, TILESIZE, Actor_Pic.hdc, actor.Frame * TILESIZE + 2 * TILESIZE * 2, 3 * TILESIZE + 4 * TILESIZE, vbSrcAnd
      BitBlt Main_Pic.hdc, 12 * TILESIZE - Xmap, 8 * TILESIZE - Ymap, TILESIZE, TILESIZE, Actor_Pic.hdc, actor.Frame * TILESIZE + 2 * TILESIZE * 2, 3 * TILESIZE, vbSrcPaint
     End If
  End If
  
  Case SNOW_HOUSE_MAP
   If ARTIN_EVENT = False Then
      BitBlt Main_Pic.hdc, 7 * TILESIZE - Xmap, 5 * TILESIZE - Ymap, TILESIZE, TILESIZE, Actor_Pic.hdc, actor.Frame * TILESIZE + 3 * TILESIZE * 2, DDOWN * TILESIZE + 4 * TILESIZE, vbSrcAnd
      BitBlt Main_Pic.hdc, 7 * TILESIZE - Xmap, 5 * TILESIZE - Ymap, TILESIZE, TILESIZE, Actor_Pic.hdc, actor.Frame * TILESIZE + 3 * TILESIZE * 2, DDOWN * TILESIZE, vbSrcPaint
   End If
   
  Case SCHOOL_MAP
   BitBlt Main_Pic.hdc, 10 * TILESIZE - Xmap, 4 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE + 2 * TILESIZE, 2 * TILESIZE, vbSrcAnd
   BitBlt Main_Pic.hdc, 10 * TILESIZE - Xmap, 4 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE, 2 * TILESIZE, vbSrcPaint
       
  Case TOWER_MAP1
  If L_EVENT = True And TOWER1_EVENT = False Then
   BitBlt Main_Pic.hdc, 7 * TILESIZE - Xmap, 2 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE + 2 * TILESIZE, 4 * TILESIZE, vbSrcAnd
   BitBlt Main_Pic.hdc, 7 * TILESIZE - Xmap, 2 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE, 4 * TILESIZE, vbSrcPaint
  End If
  
  Case TOWER_MAP2
  If L_EVENT = True And TOWER2_EVENT = False Then
   BitBlt Main_Pic.hdc, 7 * TILESIZE - Xmap, 2 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE + 2 * TILESIZE, 6 * TILESIZE, vbSrcAnd
   BitBlt Main_Pic.hdc, 7 * TILESIZE - Xmap, 2 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE, 6 * TILESIZE, vbSrcPaint
  End If
  
  Case TOWER_MAP3
  If L_EVENT = True And TOWER3_EVENT = False Then
   BitBlt Main_Pic.hdc, 7 * TILESIZE - Xmap, 2 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE + 2 * TILESIZE, 8 * TILESIZE, vbSrcAnd
   BitBlt Main_Pic.hdc, 7 * TILESIZE - Xmap, 2 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE, 8 * TILESIZE, vbSrcPaint
  End If
 
  Case DESERT_TOWN
  If DESERT_EVENT = False And TOWER1_EVENT = True And TOWER2_EVENT = True And TOWER3_EVENT = True Then
   BitBlt Main_Pic.hdc, 7 * TILESIZE - Xmap, 3 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE + 2 * TILESIZE, 7 * TILESIZE, vbSrcAnd
   BitBlt Main_Pic.hdc, 7 * TILESIZE - Xmap, 3 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE, 7 * TILESIZE, vbSrcPaint
  End If
  
  Case LOTUS_MAP
  If LOTUS_EVENT1 = False Or LOTUS_EVENT2 = False Then
   BitBlt Main_Pic.hdc, 4 * TILESIZE - Xmap, 4 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE + 2 * TILESIZE, 3 * TILESIZE, vbSrcAnd
   BitBlt Main_Pic.hdc, 4 * TILESIZE - Xmap, 4 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE, 3 * TILESIZE, vbSrcPaint
  End If
  
  Case LIBRARY_MAP
  If LIBRARY_EVENT = False And LOTUS_EVENT2 = True Then
   BitBlt Main_Pic.hdc, 1 * TILESIZE - Xmap, 6 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE + 2 * TILESIZE, 5 * TILESIZE, vbSrcAnd
   BitBlt Main_Pic.hdc, 1 * TILESIZE - Xmap, 6 * TILESIZE - Ymap, TILESIZE, TILESIZE, Sprite_pic.hdc, actor.Frame * TILESIZE, 5 * TILESIZE, vbSrcPaint
  End If
  
End Select

End Sub
Sub check_dialogue()
Dim col As Integer, row As Integer
Dim text As String
Dim i As Integer, j As Integer

col = Int((actor.x + Xmap) / TILESIZE)
row = Int((actor.y + Ymap) / TILESIZE)

Select Case Current_Map
  
 Case BOTANICAL
  If col = 11 And row = 7 Then Call event_trigger
 
 Case SNOW_HOUSE_MAP
  If ARTIN_EVENT = False And col = 7 And row = 5 Then
       ARTIN_EVENT = True
       text = "Artin: Yo Rio, how come you get two girlfriend at the same time?": Call dialogue(text)
       text = "Lisna + Angelia: Excuse me, but we just met a few minutes ago": Call dialogue(text)
       text = "Rio: Ha..ha..forget what he said Lisna. He has a good sense of joking": Call dialogue(text)
       text = "Artin: Thank you for that. Anyway, did you said that you have a research thing to do?": Call dialogue(text)
       text = "Rio: That's right. We have visit the botanical research lab and find out ...": Call dialogue(text)
       text = "Rio: ...that's the story": Call dialogue(text)
       text = "Artin: I see that, so let us go together to school and report this": Call dialogue(text)
       text = "Artin join the party !": Call dialogue(text)
       player_num = player_num + 1
       Dialogue_Lbl.Caption = ""
  End If
 
 Case SCHOOL_MAP
  If L_EVENT = False And col = 10 And row = 4 Then
     L_EVENT = True
     text = lname & ": Ho..ho..have you finished the homework which I gave?": Call dialogue(text)
     text = "Angelia: Sir, we met something fishy in research lab. The story begin ..... and that's why we come here.": Call dialogue(text)
     text = lname & ": I see then. Perhaps it is caused by Lotus, student from top class": Call dialogue(text)
     text = lname & ": She has briliant IQ and achievement. Perhaps she want to eliminate other scientist so there will be no rival for her in the future": Call dialogue(text)
     text = lname & ": Her house is in the south, surrounded by deep water. I suggest you lend three MYSTIC PEARL from three towers in snowy, desert, and grass": Call dialogue(text)
     text = lname & ": With those item, visit the desert town and a magician can make an item that enable you to walk cross the water": Call dialogue(text)
     text = "Artin : So, what are we waiting for? Let's go to those towers": Call dialogue(text)
     Dialogue_Lbl.Caption = ""
  Else:
   If LIBRARY_EVENT = True And col = 10 And row = 4 Then
     text = lname & ": Ho..ho..so you have figured it out. I'm sure those silly librarian will be suffering to become the witness": Call dialogue(text)
     text = "Angelia: Darn you old Gay! How pathetic and a shame to have a lecture like you!": Call dialogue(text)
     text = lname & ": Don't you ever dare to talk like that. It's your fault RIO !!!": Call dialogue(text)
     text = lname & ": Before you step in this school, I was so handsome with athletical body. No wonder if every female students put attention on me.": Call dialogue(text)
     text = lname & ": But, since you were here ... every girls were attracted to you!": Call dialogue(text)
     text = lname & ": I became frustated, became so fatty, became a gay, and I want to kill you like I did to other scientist": Call dialogue(text)
     text = lname & ": I gave you this homework so my assasin will be able to kill you": Call dialogue(text)
     text = "Artin : That's enough! We have witness and we have broadcasting your picture and voice with this candid camera.": Call dialogue(text)
     text = "Lisna : Sorry, but your career is over!": Call dialogue(text)
     text = lname & ": Arrrg!! I'll kill you!!": Call dialogue(text)
     Dialogue_Lbl.Caption = ""
     Battle_situation = BOSS_LECTURE
     battle = True
     out_map = True
   End If
  End If
  
  Case TOWER_MAP1
   If L_EVENT = True And TOWER1_EVENT = False And col = 7 And row = 2 Then
    text = "Guardian: You want the Mystic Pearl? HOW DARE YOU !!!": Call dialogue(text)
    TOWER1_EVENT = True
    Battle_situation = BOSS_TOWER1
    battle = True
    out_map = True
   End If
  
  Case TOWER_MAP2
   If L_EVENT = True And TOWER2_EVENT = False And col = 7 And row = 2 Then
    text = "Guardian: You want the Mystic Pearl? WHAT MAKES YOU THINK YOU HAVE RIGHT TO DO IT ?!!!": Call dialogue(text)
    TOWER2_EVENT = True
    Battle_situation = BOSS_TOWER2
    battle = True
    out_map = True
   End If
  
  Case TOWER_MAP3
   If L_EVENT = True And TOWER3_EVENT = False And col = 7 And row = 2 Then
    text = "Guardian: You want the Mystic Pearl? HOW CAN YOU THINK SO WORST ?!!!": Call dialogue(text)
    TOWER3_EVENT = True
    Battle_situation = BOSS_TOWER3
    battle = True
    out_map = True
   End If
  
  Case DESERT_TOWN
   
  If col = 7 And row = 3 And _
       TOWER1_EVENT = True And _
       TOWER2_EVENT = True And _
       TOWER3_EVENT = True And _
       DESERT_EVENT = False Then
       DESERT_EVENT = True
       text = "You want me to make an item that enable you to walk on water with this 3 mystic pearl?": Call dialogue(text)
       text = "Sure...here you go! Now you can walk on the water": Call dialogue(text)
       Dialogue_Lbl.Caption = ""
        For i = 0 To MAXCOL - 1
         For j = 0 To MAXROW - 1
          If map(WORLD_MAP).grid(i, j).special = 101 Then map(WORLD_MAP).grid(i, j).special = 47
         Next j
        Next i
  End If
     
  Case LOTUS_MAP
  
  If col = 4 And row = 4 Then
     If LOTUS_EVENT1 = False Then
        LOTUS_EVENT1 = True
        ' ** Close the entrance
        map(LOTUS_MAP).grid(20, 17).value = 190
        map(LOTUS_MAP).grid(20, 17).special = 100
        text = "Lotus: It's unpolite for entering someone house without any permission. Should I teach you?": Call dialogue(text)
        Battle_situation = BOSS_LOTUS
        battle = True
        out_map = True
     Else:
       If LOTUS_EVENT2 = False Then
        LOTUS_EVENT2 = True
        ' *** open the entrance
        map(LOTUS_MAP).grid(20, 17).value = 26
        map(LOTUS_MAP).grid(20, 17).special = EXIT_MAP
        text = "Artin: Look, we must get you to the court so you can regret to what you have done in botany research lab": Call dialogue(text)
        text = "Lotus: What have I done? I done nothing! Mr " & lname & " is not my lecture. I don't have any homework to there": Call dialogue(text)
        text = "Rio: But you hire an assasin to kill the scientist in there.": Call dialogue(text)
        text = "Lotus: You fool! In that case, why the school never response for the missing of their students?": Call dialogue(text)
        text = "Angelia: Maybe because the school principal never heard of it?": Call dialogue(text)
        text = "Lotus: You know this incident, means the news has arrived in school. The only possibility is to make it nothing than a rumor": Call dialogue(text)
        text = "Lotus: and who do you think will be able to convince the principal that this is just a rumor": Call dialogue(text)
        text = "Lisna: I think I can catch your main idea. Did you mean Mr " & lname & " is behind all of this": Call dialogue(text)
        text = "Lotus: He is the director of Botanical research lab, so people won't suspicious when he said everything is fine in the botanical lab": Call dialogue(text)
        text = "Lotus: As you see, he used me and the situation here, so you would visit the three towers": Call dialogue(text)
        text = "Lotus: If you remember your history lessons, then there will be no doubt that the mystic pearl is a sacred artifact": Call dialogue(text)
        text = "Lotus: Not even the guardians will angry. If the society know this, you all will be in trouble. That's another advantage for Mr. " & lname & " that I saw.": Call dialogue(text)
        text = "Lisna: But we don't have evidence to proof your words": Call dialogue(text)
        text = "Lotus: Mr " & lname & " is a gay. His boyfriend is the librarian. I'm sure the librarian knows everything. Try to get him.": Call dialogue(text)
        text = "Artin: Now, I've seen you briliant IQ": Call dialogue(text)
        text = "Rio: I think we better hurry before something else happens": Call dialogue(text)
        Dialogue_Lbl.Caption = ""
       End If
     End If
   End If
   
   Case LIBRARY_MAP
   If col = 1 And row = 6 And LOTUS_EVENT2 = True And LIBRARY_EVENT = False Then
      text = "Librarian: So you have heard everything!? okay! okay! I'm not a Gay! He forced me to do so": Call dialogue(text)
      text = "Librarian: You see...he threat me and I can't lose my job right now...I need it": Call dialogue(text)
      text = "Angelia: It's okay, as long as you want to be the witness to what you ever heard about that barbarian lecture's action, we will free you from this misery": Call dialogue(text)
      Dialogue_Lbl.Caption = ""
      LIBRARY_EVENT = True
   End If
   
End Select

End Sub
Sub draw_whole_thing()

Call animate
    
Main_Pic.Cls
Call draw_map

Call draw_enemy_sprite

Call draw_actor

End Sub
Sub dialogue(text As String)
Dim i As Integer, out As Boolean

For i = 1 To Len(text)
 delay (5)
 Dialogue_Lbl.Caption = Left$(text, i)
Next i

out = False

Do
If GetKeyState(vbKeySpace) And KEY_DOWN Then out = True
DoEvents
Loop Until out = True

End Sub
Sub event_trigger()
Dim spriteX As Integer, spriteY As Integer
Dim sprite_direction As Integer, text As String

Select Case Current_Map
   Case LISNA_HOUSE
    If ANGEL_ARRIVE = False Then
       ANGEL_ARRIVE = True
       map(Current_Map).grid(13, 5).special = 0
       ' *** Open the Door
       map(Current_Map).grid(Xmap / TILESIZE + 7, 9).value = map(Current_Map).grid(actor.x / TILESIZE, actor.y / TILESIZE).value
       map(Current_Map).grid(Xmap / TILESIZE + 7, 9).special = EXIT_MAP
   
       spriteX = 7 * TILESIZE
   
       sprite_direction = DUP
       For spriteY = 10 * TILESIZE To 7 * TILESIZE Step -1
        delay (10)
        Call draw_whole_thing
        BitBlt Main_Pic.hdc, spriteX, spriteY, TILESIZE, TILESIZE, Actor_Pic.hdc, 1 * 64 + actor.Frame * 32, sprite_direction * 32 + TILESIZE * 4, vbSrcAnd
        BitBlt Main_Pic.hdc, spriteX, spriteY, TILESIZE, TILESIZE, Actor_Pic.hdc, 1 * 64 + actor.Frame * 32, sprite_direction * 32, vbSrcPaint
        Main_Pic.Refresh
       Next spriteY
   
       sprite_direction = DLEFT
       For spriteX = 7 * TILESIZE To 3 * TILESIZE Step -1
        delay (10)
        Call draw_whole_thing
        BitBlt Main_Pic.hdc, spriteX, spriteY, TILESIZE, TILESIZE, Actor_Pic.hdc, 1 * 64 + actor.Frame * 32, sprite_direction * 32 + TILESIZE * 4, vbSrcAnd
        BitBlt Main_Pic.hdc, spriteX, spriteY, TILESIZE, TILESIZE, Actor_Pic.hdc, 1 * 64 + actor.Frame * 32, sprite_direction * 32, vbSrcPaint
        Main_Pic.Refresh
       Next spriteX
   
       sprite_direction = DUP
       For spriteY = 7 * TILESIZE To 6 * TILESIZE Step -1
        delay (10)
        Call draw_whole_thing
        BitBlt Main_Pic.hdc, spriteX, spriteY, TILESIZE, TILESIZE, Actor_Pic.hdc, 1 * 64 + actor.Frame * 32, sprite_direction * 32 + TILESIZE * 4, vbSrcAnd
        BitBlt Main_Pic.hdc, spriteX, spriteY, TILESIZE, TILESIZE, Actor_Pic.hdc, 1 * 64 + actor.Frame * 32, sprite_direction * 32, vbSrcPaint
        Main_Pic.Refresh
       Next spriteY
   
       text = "Angelia: Hi Lisna, I heard that you're going to Botanical research center <PRESS SPACE BAR>": Call dialogue(text)
       text = "Lisna: Well, I got to finish my homework that was given by Mr. " & lname & ". Beside, holiday in home without a boyfriend is totally boring": Call dialogue(text)
       text = "Angelia: My friend who study in biology class said lately there were fishy things around there": Call dialogue(text)
       text = "Lisna: Now, what was that?": Call dialogue(text)
       text = "Angelia: She said, scientists whom visit that place were never returned. People think it may because they doing long time research": Call dialogue(text)
       text = "Angelia: However, one of the scientist is her friend who only want to pick a seed": Call dialogue(text)
       text = "Lisna: Oh well, but I don't have any choice. Beside, this mysterious become the spice for my holiday": Call dialogue(text)
       text = "Angelia: I'll go with you! The Botanical research center is on southwest from here. I brought some medicine for us.": Call dialogue(text)
       text = "Angelia join the party !": Call dialogue(text)
       player_num = player_num + 1
       Dialogue_Lbl.Caption = ""
       Exit Sub
    End If
 
  Case BOTANICAL
    If BOTANICAL_EVENT = False Then
       text = "Old man: Ho! What a cute girls! A delicious dinner meal": Call dialogue(text)
       text = "Lisna: Huh!? ": Call dialogue(text)
       text = "Old man: Uh..oh! Nothing, really ... err... are you here for taking research": Call dialogue(text)
       text = "Lisna: Yes, my lecture, Mr. " & lname & ", giving a homework for doing research. Here's the permission letter": Call dialogue(text)
       text = "Old man: Oh yes! Mr. " & lname & " is really great for choosing cute babes for my nutrition": Call dialogue(text)
       text = "Angelia: Lisna, this is no ordinary laboratory keeper. Beside I heard the laboratory keeper was supposed a young male": Call dialogue(text)
       text = "Lisna: Really? Yeah, you know...this old man is seems like a maniac": Call dialogue(text)
       
       spriteX = 17 * TILESIZE
   
       sprite_direction = DUP
       For spriteY = 9 * TILESIZE To 8 * TILESIZE Step -1
        delay (10)
        Call draw_whole_thing
        BitBlt Main_Pic.hdc, spriteX - Xmap, spriteY, TILESIZE, TILESIZE, Actor_Pic.hdc, 2 * 64 + actor.Frame * 32, sprite_direction * 32 + TILESIZE * 4, vbSrcAnd
        BitBlt Main_Pic.hdc, spriteX - Xmap, spriteY, TILESIZE, TILESIZE, Actor_Pic.hdc, 2 * 64 + actor.Frame * 32, sprite_direction * 32, vbSrcPaint
        Main_Pic.Refresh
       Next spriteY
       
       sprite_direction = DLEFT
       For spriteX = 17 * TILESIZE To 12 * TILESIZE Step -1
        delay (10)
        Call draw_whole_thing
        BitBlt Main_Pic.hdc, spriteX - Xmap, spriteY, TILESIZE, TILESIZE, Actor_Pic.hdc, 2 * 64 + actor.Frame * 32, sprite_direction * 32 + TILESIZE * 4, vbSrcAnd
        BitBlt Main_Pic.hdc, spriteX - Xmap, spriteY, TILESIZE, TILESIZE, Actor_Pic.hdc, 2 * 64 + actor.Frame * 32, sprite_direction * 32, vbSrcPaint
        Main_Pic.Refresh
       Next spriteX
       
       text = "Man: I agree with you. I've seen in school archives that this old man is not listed as a laboratory keeper": Call dialogue(text)
       text = "Old man: Indeed! I'm in mission to eliminate you all! Now Prepare!!": Call dialogue(text)
       player_num = player_num + 1
       Dialogue_Lbl.Caption = ""
       
       ' Battle with Botanical Boss
       Battle_situation = BOSS_BOTANICAL
       battle = True
       out_map = True
      
      BOTANICAL_EVENT = True
      map(BOTANICAL).grid(12, 8).special = EVENTS
      Exit Sub
     End If
       
    If BOTANICAL_EVENT2 = False Then
       text = "Man: My name is RIO. We are in the same school and I also got this homework from Mr. " & lname: Call dialogue(text)
       text = "Lisna: Nice to meet you. I'm Lisna and she's Angelia. I think we must report this incident to the school": Call dialogue(text)
       text = "Rio: Ok, it is more safe for us to go together. The school is in the east, I know the forest path to there": Call dialogue(text)
       text = "Rio: Before that, I have a friend in snow house, not far from here. Let's visit him": Call dialogue(text)
       text = "Rio join the party !": Call dialogue(text)
       Dialogue_Lbl.Caption = ""
       
       BOTANICAL_EVENT2 = True
       ' open the forest path
       map(WORLD_MAP).grid(8, 4).value = 3
       map(WORLD_MAP).grid(9, 4).value = 3
       map(WORLD_MAP).grid(8, 4).special = 0
       map(WORLD_MAP).grid(9, 4).special = 0
    End If
       
End Select
End Sub
Sub check_battle()
Dim i As Integer
 
Randomize Timer
 
Select Case Current_Map
 ' *** only this maps, below, which have enemies
 Case WORLD_MAP, LOTUS_MAP, SCHOOL_MAP, BOTANICAL, TOWER_MAP1, _
      TOWER_MAP2, TOWER_MAP3
 
 If battle_wait < 100 Then
    battle_wait = battle_wait + 1
 Else
  i = Int(Rnd * 10000)
  If i Mod 250 = 9 Then
    Battle_situation = GENERAL
    battle = True
    out_map = True
  End If
 End If
 
End Select

End Sub
Sub battle_begin()
Dim i As Byte

Call Curtain_Close

' *** Stop the Music
Call perf.Stop(seg, segstate, 0, 0)

'*** determine the music
Select Case Battle_situation
 Case GENERAL
  Randomize (2000)
  i = Int(Rnd * 4) + 4
 Case BOSS_BOTANICAL
  i = BOTANICAL_MS
 Case BOSS_TOWER1, BOSS_TOWER2, BOSS_TOWER3
  i = TOWER_MS
 Case BOSS_LOTUS
  i = LOTUS_MS
 Case BOSS_LECTURE
  i = LECTURE_MS
End Select

Call determine_music(i)

Load Battle_Frm
Battle_Frm.Show
Unload Map_Frm

End Sub
Sub main_routine()

Do
delay (10)

If open_status = False Then
   Call check_keyboard

   Call draw_whole_thing

   Main_Pic.Refresh
End If

Call ServiceBackgroundMusic

Loop Until out_map = True

If game_over = True Then
   Call stop_DIRECTX
   End
Else:
   If battle = True Then
    Call battle_begin
   End If
End If

End Sub
Sub initialize()

open_status = False
battle = False
out_map = False
game_over = False
frame_time = 0
actor.offset = 3
actor.Frame = 0
actor.direction = DDOWN
battle_wait = 0

Actor_Pic.Picture = LoadPicture(App.Path & "\images\actor_sprite_map.gif")
Sprite_pic.Picture = LoadPicture(App.Path & "\images\enemy_sprite_map.gif")

' MIDI Handler for beginning
Select Case Current_Map
 Case LISNA_HOUSE, DESERT_TOWN, SNOW_AREA_MAP, SNOW_HOUSE_MAP
  Call determine_music(PEACE_MS)
 Case LOTUS_MAP
  Call determine_music(CASTLE_MS)
 Case SCHOOL_MAP
  Call determine_music(SCHOOL_MS)
 Case Else
  Call determine_music(WORLD_MS)
End Select

End Sub
Private Sub Form_Load()
' DirectSoundHandler
Ds.SetCooperativeLevel Map_Frm.hWnd, DSSCL_NORMAL
End Sub


Private Sub Timer1_Timer()
Timer1.enabled = False
Timer1.Interval = 0

Call determine_map
Call initialize
Call main_routine

End Sub

